#pragma once
#include <States/GameState/GameBuilder/GameBuilder.h>

class GameBuilderDirector final {
public:
    GameBuilderDirector(std::unique_ptr<IGameBuilder>&& ptr_builder, const sf::VideoMode& mode, std::string  window_title, const float dynamic_object_ratio) :
        m_window_title(std::move(window_title)), m_mode(mode), m_dynamic_object_ratio(dynamic_object_ratio), m_ptr_builder(std::move(ptr_builder)) {}
    std::unique_ptr<GameState> build(IStateManager& state_manager) const;
private:
    std::string m_window_title;
    sf::VideoMode m_mode;
    float m_dynamic_object_ratio;
    std::unique_ptr<IGameBuilder> m_ptr_builder;
};
